#include "extdll.h"
#include <meta_api.h> // of course
#include "enginecallback.h"
#include "bmx_plugin.h"
#include "cstrike.h"
#include "sdk_util.h"
#include "cbase.h"
#include "const.h"
#include "weaponinfo.h"
#include "progdefs.h"
#include "scriplib.h"
#include "item.h"
#include "usrmsg.h"
#include "playerbuy.h"
#include "moneymsg.h"

bool bSpawn=false;

int giveitem;





player_extra_info_t g_PlayerInfo[MAX_PLAYERS+1];
bool bRespawn=false;
int g_msg_dest;
int g_msg_index;
int g_msg_type;
int g_map_type;

void cvar_update(void)
{
	if(g_mod_type==CSTRIKE)
	{
		CS_cvar_update();
	}

	giveitem=bmx_giveitem->value;




}
int CountInfoPlayerStart()
{
	edict_t *pent=NULL;
	int count=0;
	while((pent=UTIL_FindEntityByClassname(pent, "info_player_start"))!=NULL)
	{
		count++;
	} // end while loop
	return count;
}
int CountInfoPlayerDeathmatch()
{
	edict_t *pent=NULL;
	int count=0;
	while((pent=UTIL_FindEntityByClassname(pent, "info_player_deathmatch"))!=NULL)
	{
		count++;
	} // end while loop
	return count;
}
/*   adminmod slap     */
bool slap(int index)
{
	edict_t *pPlayer=INDEXENT(index);
	if(!UTIL_IsValidEntity(pPlayer))return true;
	/* Dock 'em five health, if they can stand it */
	if(pPlayer->v.health>10){
		pPlayer->v.dmg_inflictor=NULL;
		pPlayer->v.dmg_take=5;
		pPlayer->v.health-=5;
	}
	/* Play a random sound, varying the sound based on the mod */
	float flRndSound;
	flRndSound=RANDOM_FLOAT(0, 1);
	// Counterstrike pain sounds, suggested by Da Rope
	if(flRndSound<=0.33){
		EMIT_SOUND_DYN2(pPlayer, CHAN_VOICE, "player/bhit_flesh-3.wav", 1, ATTN_NORM, 0, PITCH_NORM);
	} else if(flRndSound<=0.66){
		EMIT_SOUND_DYN2(pPlayer, CHAN_VOICE, "player/bhit_flesh-2.wav", 1, ATTN_NORM, 0, PITCH_NORM);
	} else {
		EMIT_SOUND_DYN2(pPlayer, CHAN_VOICE, "player/pl_die1.wav", 1, ATTN_NORM, 0, PITCH_NORM);
	}
	/* Send 'em sprawling */
	pPlayer->v.velocity.x+=floor(RANDOM_FLOAT(-800,800));
	pPlayer->v.velocity.y+=floor(RANDOM_FLOAT(-800,800));
	if(pPlayer->v.velocity.z>=200){
		pPlayer->v.velocity.z-=floor(RANDOM_FLOAT(100,200));
	} else {
		pPlayer->v.velocity.z+=floor(RANDOM_FLOAT(100,200));
	}
	return false;
}
void Restore(edict_t *pEntity)
{

}
float SetTimer(float timeout)
{
	return gpGlobals->time + timeout;
}
/////////////////////////////////////////////////////////
//
//
//
bool check_cmd(edict_t *pEntity)
{
	// int i; //for loop

	if(g_mod_type==CSTRIKE&&CS_check_cmd(pEntity))return true;
	if(giveitem==1&&strcmp(CMD_ARGV(0),"give")==0)
	{
		GiveNamedItem(pEntity, CMD_ARGV(1));
		return true;
	}
	return false;
}
void GiveNamedItem(edict_t *pEdict, const char *pszName)
{
	if(strncmp(pszName,"weapon_",7)==0||strncmp(pszName,"item_",5)==0||strncmp(pszName,"ammo_",5)==0)
	{
		edict_t *pent;
		int istr=MAKE_STRING(pszName);
		pent=CREATE_NAMED_ENTITY(istr);
		if(FNullEnt(pent))
		{
			ALERT(at_console, "NULL Ent in GiveNamedItem!\n");
			return;
		}
		VARS(pent)->origin=VARS(pEdict)->origin;
		pent->v.spawnflags |=SF_NORESPAWN;
		(*gpGamedllFuncs->dllapi_table->pfnSpawn)(pent);
		(*gpGamedllFuncs->dllapi_table->pfnTouch)(pent, pEdict);
	}
}
void UTIL_ClearMenu(edict_t *pEntity)
{
	UTIL_ShowMenu(pEntity, 0, 0, false, NULL);
}
void UTIL_Speak(edict_t *pent, const char *pszSentence)
{
	EMIT_SOUND_DYN2(pent, CHAN_VOICE, pszSentence, VOL_NORM, ATTN_NORM, 0, 100);
}
bool IsHLTV(edict_t *pEdict)
{
	unsigned int wonid=g_engfuncs.pfnGetPlayerWONId(pEdict);
	if(wonid==1448)return true;
	return false;
}
int UTIL_CountTeam(int team)
{
	int count=0;
	edict_t *pEdict;
	for(int i=1; i<=MAX_PLAYERS; i++)
	{
		pEdict=INDEXENT(i);
		if(!UTIL_IsValidEntity(pEdict))
			continue;
		if(g_PlayerInfo[i].teamnumber==team)
		{
			count++;
		}
	}
	return count;
}


