#include "extdll.h"
#include <meta_api.h> // of course
#include "sdk_util.h"
#include "progdefs.h"
#include "edict.h"
#include "const.h"
#include "cbase.h"
#include "bmx_plugin.h"
#include "cstrike.h"
#include "scriplib.h"

#include "item.h"
#include "usrmsg.h"
#include "moneymsg.h"

CMoneyMsg mMSG;

CMoneyMsg::CMoneyMsg()
{
	for(int i=1;i<=MAX_PLAYERS;i++)
	{
		f_msg[i]=false;
	}
}
void CMoneyMsg::set(int index)
{
	f_msg[index]=true;
}
void CMoneyMsg::Check()
{
	if(moneymode==2)
	{
		TeamMoneyMsg(TERRORIST);
		TeamMoneyMsg(CT);
		for(int i=1;i<=MAX_PLAYERS;i++)
		{
			if(f_msg[i])
			{
				f_msg[i]=false;
			}
		}
	}
	else
	{
		for(int i=1;i<=MAX_PLAYERS;i++)
		{
			if(f_msg[i])
			{
				MoneyMsg(i);
				f_msg[i]=false;
			}
		}
	}
}
void CMoneyMsg::TeamMoneyMsg(int team)
{
	if(moneymode!=2)return;
	int value=CalcTeamMoney(team,0);
	bool inc=false;
	for(int i=1; i<=MAX_PLAYERS; i++)
	{
		edict_t *pEdict=INDEXENT(i);
		if(g_PlayerInfo[i].teamnumber==team&&UTIL_IsValidEntity(pEdict))
		{
			inc=false;
			if(last_money[i]<value)inc=true;
			MESSAGE_BEGIN(MSG_ONE, gmsgMoney, NULL, pEdict);
				WRITE_LONG(value);
				WRITE_BYTE(inc);
			MESSAGE_END();
			last_money[i]=value;
		}
	}
}
void CMoneyMsg::MoneyMsg(int index)
{
	if(moneymode==0)return;
	if(moneymode==2)
	{
		TeamMoneyMsg(g_PlayerInfo[index].teamnumber);
		return;
	}
	edict_t *pEntity=INDEXENT(index);
	if(!UTIL_IsValidEntity(pEntity))
		return;
	int value=CalcMoney(index,0);
	bool inc=false;
	if(last_money[index]<value)inc=true;
	MESSAGE_BEGIN(MSG_ONE, gmsgMoney, NULL, pEntity);
		WRITE_LONG(value);
		WRITE_BYTE(inc);
	MESSAGE_END();
	if(score_frags==7||score_deaths==7)
		UpdateScoreInfo(index);
	last_money[index]=value;
}
