#include "extdll.h"
#include <meta_api.h> // of course
#include "enginecallback.h"
#include "sdk_util.h"
#include "cbase.h"
#include "const.h"
#include "weaponinfo.h"
#include "progdefs.h"
#include "scriplib.h"
#include "bmx_plugin.h"
#include "cstrike.h"

#include "item.h"
#include "usrmsg.h"
#include "playerbuy.h"
#include "moneymsg.h"

int gmsgHudText;
int gmsgTextMsg;
int gmsgSayText;
int gmsgDeathMsg;
int gmsgScoreInfo;
int gmsgTeamInfo;
int gmsgScoreAttrib;
int gmsgInitHUD;
int gmsgSendAudio;
int gmsgShowMenu;
int gmsgVGUIMenu;
int gmsgMoney;
int gmsgResetHUD;
int gmsgTeamScore;
int gmsgCurWeapon;
int gmsgStatusIcon;
int gmsgNVGToggle;
int gmsgBattery;
int gmsgAmmoX;
int gmsgMOTD;
int gmsgDamage;
int gmsgArmorType;
int gmsgScreenShake;
int gmsgScreenFade;
int gmsgWeaponList;
int Weapons[32];

pfnMsgFunc MsgFunc=NULL;

bool MsgFunc_Void(void *value)
{
	return false;
}

bool CS_MsgFunc_TextMsg(void *value)
{
	static edict_t *pEntity;
	static int msg_dest=0;
	static char *msg_name=NULL;
	static int index=0;
	if(g_msg_index==MSGBEGIN)
	{
		pEntity=(edict_t *)value;
		index=ENTINDEX(pEntity);
		msg_dest=0;
		msg_name=NULL;
		UnknownCmd.unknown=false;
	}
	else if(g_msg_index==1)
	{
		msg_dest=*(int *)value;
	}
	else if(g_msg_index==2)
	{
		msg_name=(char *)value;
		if(strcmp(msg_name, "#Terrorists_Win")==0)
		{
			for(int i=1; i<=MAX_PLAYERS; i++)
			{
				if(g_PlayerInfo[i].teamnumber==TERRORIST)
				{
					g_PlayerInfo[i].ext_money+=elimreward;
					mMSG.set(i);
				}
			}
			if(g_map_type==DE_MAP&&ext_score!=0)
			{
				if(ext_score==1)
				{
					if(TeamScore.changed)
					{
						TeamScore.team2++;
					}
					else
					{
						TeamScore.team1++;
					}
				}
				else if(ext_score==2)
				{
					if(TeamScore.changed)
					{
						TeamScore.team2++;
					}
					else
					{
						TeamScore.team1++;
					}
				}
				bTeamScoreUpdate=true;
			}
		}
		else if(strcmp(msg_name, "#CTs_Win")==0)
		{
			for(int i=1; i<=MAX_PLAYERS; i++)
			{
				if(g_PlayerInfo[i].teamnumber==CT)
				{
					g_PlayerInfo[i].ext_money+=elimreward;
					mMSG.set(i);
				}
			}
			if(g_map_type==DE_MAP&&ext_score!=0)
			{
				if(ext_score==1)
				{
					if(TeamScore.changed)
					{
						TeamScore.team1++;
					}
					else
					{
						TeamScore.team2++;
					}
				}
				else if(ext_score==2)
				{
					if(TeamScore.changed)
					{
						TeamScore.team1--;
					}
					else
					{
						TeamScore.team2--;
					}
				}
				bTeamScoreUpdate=true;
			}
		}
		else if(strcmp(msg_name, "#Bomb_Planted")==0)
		{
			if(g_map_type==DE_MAP&&ext_score!=0)
			{
				if(ext_score==1)
				{
					if(TeamScore.changed)
					{
						TeamScore.team2++;
					}
					else
					{
						TeamScore.team1++;
					}
				}
				else if(ext_score==2)
				{
					if(TeamScore.changed)
					{
						TeamScore.team2+=2;
					}
					else
					{
						TeamScore.team1+=2;
					}
				}
				bTeamScoreUpdate=true;
			}
		}
		else if(strcmp(msg_name, "#Bomb_Defused")==0)
		{
			for(int i=1; i<=MAX_PLAYERS; i++)
			{
				if(g_PlayerInfo[i].teamnumber==CT)
				{
					g_PlayerInfo[i].ext_money+=bombreward;
					mMSG.set(i);
				}
			}
			if(g_map_type==DE_MAP&&ext_score!=0)
			{
				if(ext_score==1)
				{
					if(TeamScore.changed)
					{
						TeamScore.team1+=2;
					}
					else
					{
						TeamScore.team2+=2;
					}
				}
				else if(ext_score==2)
				{
					if(TeamScore.changed)
					{
						TeamScore.team1++;
					}
					else
					{
						TeamScore.team2++;
					}
				}
			}
			bTeamScoreUpdate=true;
		}
		else if(strcmp(msg_name, "#Target_Bombed")==0)
		{
			g_PlayerInfo[the_plant].ext_frags+=ext_point;
			for(int i=1; i<=MAX_PLAYERS; i++)
			{
				if(g_PlayerInfo[i].teamnumber==TERRORIST)
				{
					g_PlayerInfo[i].ext_money+=bombreward;
					mMSG.set(i);
				}
			}
			scoreupdate=the_plant;
			if(g_map_type==DE_MAP&&ext_score!=0)
			{
				if(ext_score==1)
				{
					if(TeamScore.changed)
					{
						TeamScore.team2++;
					}
					else
					{
						TeamScore.team1++;
					}
				}
				else if(ext_score==2)
				{
				}
				bTeamScoreUpdate=true;
			}
		}
		else if(strcmp(msg_name, "#Target_Saved")==0)
		{
			for(int i=1; i<=MAX_PLAYERS; i++)
			{
				if(g_PlayerInfo[i].teamnumber==CT)
				{
					g_PlayerInfo[i].ext_money+=timeupreward;
					mMSG.set(i);
				}
			}
			if(ext_score==2)
			{
			}
		}
		else if(strcmp(msg_name, "#VIP_Escaped")==0)
		{
			g_PlayerInfo[the_vip].ext_frags+=ext_point;
			g_PlayerInfo[the_vip].ext_money+=vipreward;
			for(int i=1; i<=MAX_PLAYERS; i++)
			{
				if(g_PlayerInfo[i].teamnumber==CT)
				{
					g_PlayerInfo[i].ext_money+=vipreward;
					mMSG.set(i);
				}
			}
			scoreupdate=the_vip;
		}
		else if(strcmp(msg_name, "#VIP_Assassinated")==0)
		{
			for(int i=1; i<=MAX_PLAYERS; i++)
			{
				if(g_PlayerInfo[i].teamnumber==TERRORIST)
				{
					g_PlayerInfo[i].ext_money+=vipreward;
					mMSG.set(i);
				}
			}
		}
		else if(strcmp(msg_name, "#VIP_Not_Escaped")==0)
		{
			for(int i=1; i<=MAX_PLAYERS; i++)
			{
				if(g_PlayerInfo[i].teamnumber==TERRORIST)
				{
					g_PlayerInfo[i].ext_money+=timeupreward;
					mMSG.set(i);
				}
			}
		}
		else if(strcmp(msg_name, "#Terrorists_Escaped")==0)
		{
			for(int i=1; i<=MAX_PLAYERS; i++)
			{
				if(g_PlayerInfo[i].teamnumber==TERRORIST)
				{
					g_PlayerInfo[i].ext_money+=escreward;
					mMSG.set(i);
				}
			}
		}
		else if(strcmp(msg_name, "#CTs_PreventEscape")==0)
		{
			for(int i=1; i<=MAX_PLAYERS; i++)
			{
				if(g_PlayerInfo[i].teamnumber==CT)
				{
					g_PlayerInfo[i].ext_money+=escreward;
					mMSG.set(i);
				}
			}
		}
		else if(strcmp(msg_name, "#Terrorists_Not_Escaped")==0)
		{
			for(int i=1; i<=MAX_PLAYERS; i++)
			{
				if(g_PlayerInfo[i].teamnumber==CT)
				{
					g_PlayerInfo[i].ext_money+=timeupreward;
					mMSG.set(i);
				}
			}
		}
		else if(strcmp(msg_name, "#Defusing_Bomb_With_Defuse_Kit")==0)
		{
			the_defuse=index;
		}
		else if(strcmp(msg_name, "#Defusing_Bomb_Without_Defuse_Kit")==0)
		{
			the_defuse=index;
		}
		else if(strcmp(msg_name, "#All_Hostages_Rescued")==0)
		{
			for(int i=1; i<=MAX_PLAYERS; i++)
			{
				if(g_PlayerInfo[i].teamnumber==CT)
				{
					g_PlayerInfo[i].ext_money+=(hosreward*2);
					mMSG.set(i);
				}
			}
		}
		else if(strcmp(msg_name, "#Hostages_Not_Rescued")==0)
		{
			for(int i=1; i<=MAX_PLAYERS; i++)
			{
				if(g_PlayerInfo[i].teamnumber==TERRORIST)
				{
					g_PlayerInfo[i].ext_money+=timeupreward;
					mMSG.set(i);
				}
				else if(g_PlayerInfo[i].teamnumber==CT)
				{
					if(HosRescued>0)
					{
						g_PlayerInfo[i].ext_money+=HosRescued*(hosreward*3/4);
						mMSG.set(i);
					}
				}
			}
		}
		else if(strcmp(msg_name, "#Killed_Hostage")==0)
		{
			Hostages--;
			g_PlayerInfo[index].hostagekill++;
			g_PlayerInfo[index].ext_frags-=ext_point;
			g_PlayerInfo[index].ext_money-=killhostage;
			if(g_PlayerInfo[index].ext_money<0)
			{
				g_PlayerInfo[index].ext_money=0;
			}
			mMSG.set(index);
		}
		else if(strcmp(msg_name, "#Game_unknown_command")==0)
		{
			UnknownCmd.unknown=true;
		}
	 }
	 else if(g_msg_index==3&&UnknownCmd.unknown)
	 {
		 sprintf(UnknownCmd.command,"say %s\n",(char *)value);
	 }
	 else if(g_msg_index==MSGEND)
	 {
		 if(moneymode>0)
		 {
			 mMSG.Check();
		 }
		 if(bTeamScoreUpdate)
		 {
			 UpdateTeamScore();
			 bTeamScoreUpdate=false;
			 CS_Update();
		 }
		 if(scoreupdate>0)
		 {
			 UpdateScoreInfo(scoreupdate);
			 scoreupdate=0;
		 }
		 if(UnknownCmd.unknown)
		 {
			 UnknownCmd.unknown=false;
			 if(sayunknown==1&&!IsBot(pEntity))
			 {
				 CLIENT_COMMAND(pEntity,UnknownCmd.command);
			 }
		 }
	 }
	 return false;
}

bool CS_MsgFunc_DeathMsg(void *value)
{
	if(bRespawn)
		return false;
	static int killer=0;
	static int victim=0;
	static int headshot=0;
	if(g_msg_index==1)
	{
		killer=*(int *)value;
	}
	else if(g_msg_index==2)
	{
		victim=*(int *)value;
	}
	else if(g_msg_index==3)
	{
		headshot=*(int *)value;
	}
	else if(g_msg_index==MSGEND)
	{
		if(killer==0||killer==victim)
		{
			g_PlayerInfo[killer].frags--;
			g_PlayerInfo[victim].deaths++;
			g_PlayerInfo[killer].suicides++;
			g_PlayerInfo[victim].damage-=100;
		}
		else if(g_PlayerInfo[killer].teamnumber!=g_PlayerInfo[victim].teamnumber)
		{
			//killer==0 worldspawn
			g_PlayerInfo[killer].ext_money+=killenemy;
			g_PlayerInfo[killer].frags++;
			g_PlayerInfo[victim].deaths++;
			g_PlayerInfo[killer].headshots+=headshot;
			if(g_PlayerInfo[victim].attrib==VIP)//Vip assasin
			{
				g_PlayerInfo[killer].ext_frags+=ext_point;
				g_PlayerInfo[killer].ext_money+=vipreward;
			}
			if(killer!=0 && f_firstBlood==0)//firstBlood
			{
				char msg[100];
				sprintf(msg, "%s drew first blood!\n", STRING(INDEXENT(killer)->v.netname));
				pMSG.set(msg);
				g_PlayerInfo[killer].ext_frags+=1;
				f_firstBlood=1;
			}
		}
		else if(g_PlayerInfo[killer].teamnumber==g_PlayerInfo[victim].teamnumber)
		{
			g_PlayerInfo[killer].frags--;
			g_PlayerInfo[killer].teamkills++;
			g_PlayerInfo[killer].ext_money-=killmate;
			g_PlayerInfo[victim].ext_money+=killmate;
			if(g_PlayerInfo[killer].ext_money<0)
			{
				g_PlayerInfo[killer].ext_money=0;
			}
			if(!IsBot(INDEXENT(killer))&&!IsBot(INDEXENT(victim))&&tkslap==1)
			{
				g_PlayerInfo[victim].tkmenu.menu=true;
				g_PlayerInfo[victim].tkmenu.killer=killer;
				g_PlayerInfo[victim].tkmenu.count=20;
			}
		}
		g_PlayerInfo[victim].nightvision=false;
		g_PlayerInfo[victim].nvgtoggle=false;
		g_PlayerInfo[victim].defuser=false;

		g_PlayerInfo[victim].primid=0;
		g_PlayerInfo[victim].secid=0;

		memset(&g_PlayerInfo[victim].curweap,0,sizeof(CurWeapon_t));
		memset(&g_PlayerInfo[victim].ammo,0,sizeof(int)*16);
		pMSG.check();
		if(g_PlayerInfo[victim].tkmenu.menu)
		{
			g_PlayerInfo[victim].tkmenu.menu=false;
			g_PlayerInfo[victim].menustate=MENU_TK;
			UTIL_ShowMenu(INDEXENT(victim), 3, -1, false, " Slap the TKer?\n\n 1. Yes\n 0. No");
		}

		UpdateScoreInfo(victim);
	}
	return false;
}

bool MsgFunc_ScoreInfo(void *value)
{
	static int index=0;
	if(g_msg_index==1)
	{
		index=*(int *)value;
		if(index<=0||MAX_PLAYERS<index)
		{
			index=0;
		}
	}
	else if(g_msg_index==2)
	{
		g_PlayerInfo[index].frags=*(int *)value;
	}
	else if(g_msg_index==3)
	{
		g_PlayerInfo[index].deaths=*(int *)value;
	}
	else if(g_msg_index==4)
	{
		g_PlayerInfo[index].playerclass=*(int *)value;
	}
	else if(g_msg_index==5)
	{
		g_PlayerInfo[index].teamnumber=*(int *)value;
	}
	return false;
}

bool CS_MsgFunc_ScoreInfo(void *value)
{
	static int index=0;
	if(g_msg_index==1)
	{
		index=*(int *)value;
		if(index<=0||MAX_PLAYERS<index)
		{
			index=0;
		}
	}
	else if(g_msg_index==2)
	{
		*(int *)value=ScoreFrag(index);
		return true;
	}
	else if(g_msg_index==3)
	{
		*(int *)value=ScoreDeath(index);
		return true;
	}
	else if(g_msg_index==4)
	{
		g_PlayerInfo[index].playerclass=*(int *)value;
	}
	else if(g_msg_index==5)
	{
		g_PlayerInfo[index].teamnumber=*(int *)value;

	}
	else if(g_msg_index==MSGEND)
	{

	}
	return false;
}

bool CS_MsgFunc_TeamInfo(void *value)
{
	static int index=0;
	if(g_msg_index==1)
	{
		index=*(int *)value;
	}
	if(g_msg_index==2)
	{
		char *teamname=(char *)value;
		strncpy(g_PlayerInfo[index].teamname,teamname,MAX_TEAM_NAME);
		if(strcmp(teamname,"TERRORIST")==0)
		{
			g_PlayerInfo[index].teamnumber=TERRORIST;
		}
		else if(strcmp(teamname,"CT")==0)
		{
			g_PlayerInfo[index].teamnumber=CT;
		}
		else
		{
			g_PlayerInfo[index].teamnumber=NONE;
		}
	}
	else if(g_msg_index==MSGEND)
	{

	}
	return false;
}

bool CS_MsgFunc_ScoreAttrib(void *value)
{
	MsgFunc_ScoreAttrib(value);
	static int index=0;
	static edict_t *pEntity;
	if(g_msg_index==MSGBEGIN)
	{
		pEntity=(edict_t *)value;
	}
	else if(g_msg_index==1)
	{
		index=*(int *)value;
	}
	else if(g_msg_index==MSGEND)
	{
		if(g_PlayerInfo[index].attrib==VIP)//VIP
		{
			the_vip=index;
		}
	}
	return false;
}

bool MsgFunc_ScoreAttrib(void *value)
{
	static int index=0;
	static edict_t *pEntity;
	if(g_msg_index==MSGBEGIN)
	{
		pEntity=(edict_t *)value;
	}
	else if(g_msg_index==1)
	{
		index=*(int *)value;
	}
	else if(g_msg_index==2)
	{
		if(g_PlayerInfo[index].teamnumber==g_PlayerInfo[ENTINDEX(pEntity)].teamnumber)
		{
			g_PlayerInfo[index].attrib=*(int *)value;
		}
	}
	return false;
}

bool MsgFunc_InitHUD(void *value)
{
	static int index=0;
	static edict_t *pEntity;
	if(g_msg_index==MSGBEGIN)
	{

		pEntity=(edict_t *)value;
		index=ENTINDEX(pEntity);
		if(g_PlayerInfo[index].bInitHUD)
			return false;
		g_PlayerInfo[index].bInitHUD=true;
		g_PlayerInfo[index].time=gpGlobals->time;

		memset(&g_PlayerInfo[index].curweap,0,sizeof(CurWeapon_t));
		g_PlayerInfo[index].menustate=MENU_NONE;

	}
	return false;
}

bool CS_MsgFunc_InitHUD(void *value)
{
	MsgFunc_InitHUD(value);
	static int index=0;
	static edict_t *pEntity;
	if(g_msg_index==MSGBEGIN)
	{
		pEntity=(edict_t *)value;
		index=ENTINDEX(pEntity);
		if(!IsHLTV(pEntity)&&changetype!=0)
		{
			edict_t *pEdict=NULL;
			int count=2;
			for(int x=1; x<=gpGlobals->maxClients; x++)
			{
				pEdict=INDEXENT(x);
				if(!UTIL_IsValidEntity(pEdict)||pEntity==pEdict)
					continue;
				if(!IsHLTV(pEdict))count++;
			}
			int info_player_start=CountInfoPlayerStart()+CountInfoPlayerDeathmatch();
			int room=info_player_start-count;
			if(room<=0)
			{
				char cmd[256];
				sprintf(cmd, "kick \"%s\"\n", STRING(pEntity->v.netname));
				SERVER_COMMAND(cmd);
				return false;
			}
		}
		g_PlayerInfo[index].ext_money=startmoney;
		g_PlayerInfo[index].nightvision=false;
		g_PlayerInfo[index].nvgtoggle=false;
		g_PlayerInfo[index].defuser=false;
		g_PlayerInfo[index].chooseteam=0;
		g_PlayerInfo[index].radiotime=0;
		g_PlayerInfo[index].hostagekill=0;
		if(IsBot(pEntity)==false&&IsHLTV(pEntity)==false)
		{
			if(autojoin==1)
			{
				auto_join(pEntity);
			}
		}
	}
	return false;
}

bool CS_MsgFunc_SendAudio(void *value)
{
	static char *audio=NULL;
	static bool icon_status=false;
	static int index=0;
	static int listen=0;
	static edict_t *pEntity;
	if(g_msg_index==MSGBEGIN)
	{
		pEntity=(edict_t *)value;
		listen=ENTINDEX(pEntity);
	}
	else if(g_msg_index==1)
	{
		index=*(int *)value;
		if(listen>0&&listen==index)
		{
		}
	}
	else if(g_msg_index==2)
	{
		audio=(char *)value;
		if(strcmp(audio,"%!MRAD_terwin")==0)
		{
			if(TeamScore.changed)
			{
				if(TeamScore.lastlose==1)
				{
					TeamScore.losecount++;
					if(TeamScore.losecount>3)TeamScore.losecount=3;
				}
				else
				{
					TeamScore.losecount=0;
				}
				TeamScore.team2++;
				TeamScore.lastlose=1;
			}
			else
			{
				if(TeamScore.lastlose==2)
				{
					TeamScore.losecount++;
					if(TeamScore.losecount>3)TeamScore.losecount=3;
				}
				else
				{
					TeamScore.losecount=0;
				}
				TeamScore.team1++;
				TeamScore.lastlose=2;
			}
			bTeamScoreUpdate=true;
			for(int i=1; i<=MAX_PLAYERS; i++)
			{
				if(g_PlayerInfo[i].teamnumber==TERRORIST)
				{
					g_PlayerInfo[i].ext_money+=winreward;
					g_PlayerInfo[i].teamwins++;
					if(Hostages>0)
					{
						g_PlayerInfo[i].ext_money+=Hostages*(hosreward*3/20);//Surviving Hostage Bonus $150
					}
					mMSG.set(i);
				}
				else if(g_PlayerInfo[i].teamnumber==CT)
				{
					g_PlayerInfo[i].ext_money+=roundmoney;
					if(TeamScore.changed)
					{
						if(TeamScore.team1==0)g_PlayerInfo[i].ext_money-=(roundmoney/15);
						if(TeamScore.lastlose==1)
						{
							g_PlayerInfo[i].ext_money+=loser_money*TeamScore.losecount;
						}
					}
					else
					{
						if(TeamScore.team2==0)g_PlayerInfo[i].ext_money-=(roundmoney/15);
						if(TeamScore.lastlose==2)
						{
							g_PlayerInfo[i].ext_money+=loser_money*TeamScore.losecount;
						}
					}
					mMSG.set(i);
				}
			}
		}
		else if(strcmp(audio,"%!MRAD_ctwin")==0)
		{
			TeamScore.ctwins++;
			if(TeamScore.changed)
			{
				if(TeamScore.lastlose==2)
				{
					TeamScore.losecount++;
					if(TeamScore.losecount>3)TeamScore.losecount=3;
				}
				else
				{
					TeamScore.losecount=0;
				}
				TeamScore.team1++;
				TeamScore.lastlose=2;
			}
			else
			{
				if(TeamScore.lastlose==1)
				{
					TeamScore.losecount++;
					if(TeamScore.losecount>3)TeamScore.losecount=3;
				}
				else
				{
					TeamScore.losecount=0;
				}
				TeamScore.team2++;
				TeamScore.lastlose=1;
			}
			bTeamScoreUpdate=true;
			for(int i=1; i<=MAX_PLAYERS; i++)
			{
				if(g_PlayerInfo[i].teamnumber==CT)
				{
					g_PlayerInfo[i].ext_money+=winreward;
					g_PlayerInfo[i].teamwins++;
					if(HosRescued>0)
					{
						g_PlayerInfo[i].ext_money+=HosRescued*(hosreward*3/4);
					}
					mMSG.set(i);
				}
				else if(g_PlayerInfo[i].teamnumber==TERRORIST)
				{
					g_PlayerInfo[i].ext_money+=roundmoney;
					if(TeamScore.changed)
					{
						if(TeamScore.team2==0)g_PlayerInfo[i].ext_money-=(roundmoney/15);
						if(TeamScore.lastlose==2)
						{
							g_PlayerInfo[i].ext_money+=loser_money*TeamScore.losecount;
						}
					}
					else
					{
						if(TeamScore.team1==0)g_PlayerInfo[i].ext_money-=(roundmoney/15);
						if(TeamScore.lastlose==1)
						{
							g_PlayerInfo[i].ext_money+=loser_money*TeamScore.losecount;
						}
					}
					mMSG.set(i);
				}
			}
		}
		else if(strcmp(audio,"%!MRAD_rounddraw")==0)
		{
			TeamScore.lastlose=0;
			TeamScore.losecount=0;
		}
	 }
	 else if(g_msg_index==MSGEND)
	 {
		 if(bTeamScoreUpdate)
		 {
			 UpdateTeamScore();
			 bTeamScoreUpdate=false;
		 }
		 if(scoreupdate>0)
		 {
			 UpdateScoreInfo(scoreupdate);
			 scoreupdate=0;
		 }
	 }
	 return false;
}
bool CS_MsgFunc_ShowMenu(void *value)
{
	static bool clear;
	static edict_t *pEntity;
	if(g_msg_index==MSGBEGIN)
	{
		pEntity=(edict_t *)value;
		clear=false;
	}
	else if(g_msg_index==4)
	{
		char *pText=(char *)value;
		if(autojoin==1)
		{
			if(strcmp(pText,"#Terrorist_Select")==0||strcmp(pText,"#CT_Select")==0)
			{
				clear=true;
			}
		}
	}
	else if(g_msg_index==MSGEND)
	{
		if(clear)
			UTIL_ClearMenu(pEntity);
	}
	return false;
}
bool CS_MsgFunc_Money(void *value)
{
	static int index=0;
	static edict_t *pEntity;
	if(g_msg_index==MSGBEGIN)
	{
		pEntity=(edict_t *)value;
		index=ENTINDEX(pEntity);
	}
	else if(g_msg_index==1)
	{
		int money=*(int *)value;
		g_PlayerInfo[index].money=money;
		if(moneymode>0)
		{
			*(int *)value=CalcMoney(index,0);
		}
		else if(moneymode<0)
		{
			*(int *)value=0;
		}
		return true;
	}
	else if(g_msg_index==MSGEND)
	{
		if(score_frags==7||score_deaths==7)
			UpdateScoreInfo(index);
	}
	return false;
}
int cur_round=-1;
bool CS_MsgFunc_ResetHUD(void *value)
{
	static int index=0;
	static edict_t *pEntity;
	if(g_msg_index==MSGBEGIN)
	{
		pEntity=(edict_t *)value;
		index=ENTINDEX(pEntity);
		g_PlayerInfo[index].tkmenu.killer=0;
		g_PlayerInfo[index].tkmenu.count=0;
		UTIL_ClearMenu(pEntity);
		g_PlayerInfo[index].hegrenade.index=0;
		g_PlayerInfo[index].hegrenade.origin=pEntity->v.origin;
		g_PlayerInfo[index].hegrenade.time=-100;

		g_PlayerInfo[index].menustate=MENU_NONE;
		int penalty=hkpenalty;
		if(cur_round==round&&g_PlayerInfo[index].hostagekill>0)
		{
			pEntity->v.health-=(penalty*g_PlayerInfo[index].hostagekill);
			if(pEntity->v.health<=0)
			{
				(*gpGamedllFuncs->dllapi_table->pfnClientKill)(pEntity);
			}
			g_PlayerInfo[index].hostagekill=0;
		}
		if(UTIL_IsValidEntity(pEntity))
		{
			if(g_PlayerInfo[index].teamnumber==TERRORIST||g_PlayerInfo[index].teamnumber==CT)
			{
				if(moneymode==-1)
				{
					for(buyitem_t *item=buyitems; item->name; item++)
					{
						GiveNamedItem(pEntity, item->name);
					}
				}
			}
		}
	}
	else if(g_msg_index==MSGEND)
	{
		CS_Update();
		if(showround!=0)UTIL_HudMessage(pEntity, round_tparms,UTIL_VarArgs("Round %d",round+1));

	}
	return false;
}
bool CS_MsgFunc_TeamScore(void *value)
{
	static int ScoreTeam=0;
	if(g_msg_index==MSGBEGIN)
	{
		ScoreTeam=0;
	}
	else if(g_msg_index==1)
	{
		char *teamname=(char *)value;
		if(strcmp(teamname, "TERRORIST")==0)
		{
			ScoreTeam=TERRORIST;
		}
		else if(strcmp(teamname, "CT")==0)
		{
			ScoreTeam=CT;
		}
	}
	else if(g_msg_index==2)
	{
		if(ScoreTeam==TERRORIST)
		{
			if(TeamScore.changed)
			{
				*(int *)value=TeamScore.team2;
			}
			else
			{
				*(int *)value=TeamScore.team1;
			}
		}
		else if(ScoreTeam==CT)
		{
			if(TeamScore.changed)
			{
				*(int *)value=TeamScore.team1;
			}
			else
			{
				*(int *)value=TeamScore.team2;
			}
		}
		return true;
	}
	return false;
}
bool CS_MsgFunc_StatusIcon(void *value)
{
	static bool icon_status=false;
	static int index=0;
	static edict_t *pEntity;
	if(g_msg_index==MSGBEGIN)
	{
		pEntity=(edict_t *)value;
		index=ENTINDEX(pEntity);
	}
	else if(g_msg_index==1)
	{
		icon_status=*(int *)value;
	}
	else if(g_msg_index==2)
	{
		if(strcmp((char *)value, "buyzone")==0)
		{
			g_PlayerInfo[index].buyzone=icon_status;
		}
		else if(strcmp((char *)value, "defuser")==0)
		{
			g_PlayerInfo[index].defuser=icon_status;
		}
	}
	else if(g_msg_index==MSGEND)
	{
		if(!bRespawn&&g_PlayerInfo[index].buyzone&&IsAlive(pEntity)&&g_PlayerInfo[index].last_weapons!=0)
		{
			weapon_t *slotweap;
			for(weapon_t *weapon=weapons; weapon->Name; weapon++)
			{
				if(weapon->iSlot!=2&&weapon->iSlot!=4&&g_PlayerInfo[index].last_weapons &(1<<weapon->iId))
				{
					slotweap=weapon_lookup(pEntity, weapon->iSlot);
					if(moneymode!=-1&&multiweapons==0&&slotweap&&slotweap->Name)
					{
						FakeClientCommand(pEntity, slotweap->Name);
						FakeClientCommand(pEntity, "drop",slotweap->Name, NULL);
					}
					GiveNamedItem(pEntity,weapon->Name);
					FakeClientCommand(pEntity, weapon->Name);
				}
			}
			g_PlayerInfo[index].last_weapons=0;
		}
	}
	return false;
}
bool MsgFunc_Battery(void *value)
{
	static int index=0;
	static edict_t *pEntity;
	if(g_msg_index==MSGBEGIN)
	{
		pEntity=(edict_t *)value;
		index=ENTINDEX(pEntity);
	}
	else if(g_msg_index==1)
	{
		g_PlayerInfo[index].battery=*(int *)value;
	}
	return false;
}
bool MsgFunc_CurWeapon(void *value)
{
	static int index=0;
	static edict_t *pEntity;
	static int id,clip=0;
	if(g_msg_index==MSGBEGIN)
	{
		pEntity=(edict_t *)value;
		index=ENTINDEX(pEntity);
	}
	else if(g_msg_index==2)
	{
		id=*(int *)value;
	}
	else if(g_msg_index==3)
	{
		clip=*(int *)value;
	}
	else if(g_msg_index==MSGEND)
	{

		g_PlayerInfo[index].curweap.id=id;
		g_PlayerInfo[index].curweap.clip=clip;
	}
	return false;
}
bool MsgFunc_AmmoX(void *value)
{
	static int index=0;
	static edict_t *pEntity;
	static int ammox=0;
	static int count=0;
	if(g_msg_index==MSGBEGIN)
	{
		pEntity=(edict_t *)value;
		index=ENTINDEX(pEntity);
	}
	else if(g_msg_index==1)
	{
		ammox=*(int *)value;
	}
	else if(g_msg_index==2)
	{
		count=*(int *)value;
	}
	else if(g_msg_index==MSGEND)
	{
		if(0<ammox&&ammox<=15)
		{
			g_PlayerInfo[index].ammo[ammox]=count;
		}
	}
	return false;
}

bool CS_MsgFunc_Damage(void *value)
{
	static int index=0;
	static edict_t *pEntity;
	static int attack,dmg_take;
	static Vector origin;
	if(g_msg_index==MSGBEGIN)
	{
		pEntity=(edict_t *)value;
		index=ENTINDEX(pEntity);
	}
	else if(g_msg_index==4)
	{
		origin.x=*(float *)value;
	}
	else if(g_msg_index==5)
	{
		origin.y=*(float *)value;
	}
	else if(g_msg_index==6)
	{
		origin.z=*(float *)value;
		edict_t *dmg_inflictor=pEntity->v.dmg_inflictor;
		attack=0;
		dmg_take=pEntity->v.dmg_take;
		if(dmg_take>pEntity->v.max_health)dmg_take=pEntity->v.max_health;
		if(dmg_take>g_PlayerInfo[index].last_health)dmg_take=g_PlayerInfo[index].last_health;
		g_PlayerInfo[index].last_health=pEntity->v.health;
		if(dmg_take<0)dmg_take=0;
		if(dmg_inflictor && dmg_inflictor->v.flags & FL_CLIENT)
		{
			attack=ENTINDEX(dmg_inflictor);
		}
		else
		{
			for(int i=1; i<=MAX_PLAYERS; i++)
			{
				if(g_PlayerInfo[i].hegrenade.index>0)
				{
					float time=gpGlobals->time - g_PlayerInfo[i].hegrenade.time;
					if(0<time&&time<0.3)
					{
						float dist=(g_PlayerInfo[i].hegrenade.origin-origin).Length();
						if(dist<50)
						{
							attack=i;
							break;
						}
					}
				}
			}
		}
		if(attack==0||index==attack)
		{
			g_PlayerInfo[index].damage-=dmg_take;
		}
		else if(g_PlayerInfo[index].teamnumber!=g_PlayerInfo[attack].teamnumber)
		{
			g_PlayerInfo[attack].damage2enemy+=dmg_take;
			g_PlayerInfo[attack].damage+=dmg_take;
			g_PlayerInfo[index].damage-=dmg_take;
		}
		else if(g_PlayerInfo[index].teamnumber==g_PlayerInfo[attack].teamnumber)
		{
			g_PlayerInfo[attack].damage-=dmg_take;
			g_PlayerInfo[index].damage-=dmg_take;
		}
	}
	return false;
}
bool MsgFunc_MOTD(void *value)
{
	static int index=0;
	static edict_t *pEntity;
	static char *message=NULL;
	if(g_msg_index==MSGBEGIN)
	{
		pEntity=(edict_t *)value;
		index=ENTINDEX(pEntity);
	}
	else if(g_msg_index==1)
	{
		// *(int *)value=false;
	}
	else if(g_msg_index==2)
	{
		message=(char *)value;
	}
	else if(g_msg_index==MSGEND)
	{
	}
	return false;
}
bool MsgFunc_ArmorType(void *value)
{
	static int index=0;
	static edict_t *pEntity;
	if(g_msg_index==MSGBEGIN)
	{
		pEntity=(edict_t *)value;
		index=ENTINDEX(pEntity);
	}
	else if(g_msg_index==1)
	{
		g_PlayerInfo[index].armortype=*(int *)value;
	}
	return false;
}

bool MsgFunc_WeaponList(void *value)
{
	static int slot=0;
	static int id=0;
	if(g_msg_index==6)
	{
		slot=*(int *)value;
	}
	else if(g_msg_index==8)
	{
		id=*(int *)value;
		Weapons[id]=slot;
	}
	return false;
}
