#ifndef USERMSG_H
#define USERMSG_H

extern int gmsgScreenShake;
extern int gmsgScreenFade;

extern int gmsgArmorType;
extern int gmsgDamage;
extern int gmsgHudText;
extern int gmsgTextMsg;
extern int gmsgSayText;
extern int gmsgDeathMsg;
extern int gmsgScoreInfo;
extern int gmsgTeamInfo;
extern int gmsgScoreAttrib;
extern int gmsgInitHUD;
extern int gmsgSendAudio;
extern int gmsgShowMenu;
extern int gmsgVGUIMenu;
extern int gmsgMoney;
extern int gmsgResetHUD;
extern int gmsgTeamScore;
extern int gmsgCurWeapon;
extern int gmsgStatusIcon;
extern int gmsgNVGToggle;
extern int gmsgBattery;
extern int gmsgAmmoX;
extern int gmsgMOTD;
extern int gmsgWeaponList;

typedef bool (*pfnMsgFunc)(void *value);
extern pfnMsgFunc MsgFunc;

bool MsgFunc_Void(void *value);
bool CS_MsgFunc_TextMsg(void *value);
bool CS_MsgFunc_DeathMsg(void *value);

bool MsgFunc_ScoreInfo(void *value);//
bool CS_MsgFunc_ScoreInfo(void *value);

bool CS_MsgFunc_TeamInfo(void *value);

bool MsgFunc_ScoreAttrib(void *value);//
bool CS_MsgFunc_ScoreAttrib(void *value);

bool MsgFunc_InitHUD(void *value);//
bool CS_MsgFunc_InitHUD(void *value);

bool CS_MsgFunc_SendAudio(void *value);
bool CS_MsgFunc_ShowMenu(void *value);
bool CS_MsgFunc_Money(void *value);
bool CS_MsgFunc_ResetHUD(void *value);
bool CS_MsgFunc_TeamScore(void *value);
bool CS_MsgFunc_StatusIcon(void *value);
bool MsgFunc_Battery(void *value);
bool MsgFunc_CurWeapon(void *value);
bool MsgFunc_AmmoX(void *value);


bool CS_MsgFunc_Damage(void *value);

bool MsgFunc_MOTD(void *value);
bool MsgFunc_ArmorType(void *value);

bool MsgFunc_WeaponList(void *value);

#endif // USERMSG_H