#ifndef ITEM_H
#define ITEM_H

#define WEAPON_P228 1
#define WEAPON_UNKNOWN2 2//
#define WEAPON_SCOUT 3
#define WEAPON_HEGRENADE 4//
#define WEAPON_XM1014 5
#define WEAPON_C4 6//
#define WEAPON_MAC10 7
#define WEAPON_AUG 8
#define WEAPON_SMOKEGRENADE 9//
#define WEAPON_ELITE 10
#define WEAPON_FIVESEVEN 11
#define WEAPON_UMP45 12
#define WEAPON_SG550 13
#define WEAPON_UNKNOWN14 14//
#define WEAPON_UNKNOWN15 15//
#define WEAPON_USP 16
#define WEAPON_GLOCK18 17
#define WEAPON_AWP 18
#define WEAPON_MP5NAVY 19
#define WEAPON_M249 20
#define WEAPON_M3 21
#define WEAPON_M4A1 22
#define WEAPON_TMP 23
#define WEAPON_G3SG1 24
#define WEAPON_FLASHBANG 25//
#define WEAPON_DEAGLE 26
#define WEAPON_SG552 27
#define WEAPON_AK47 28
#define WEAPON_KNIFE 29//
#define WEAPON_P90 30

struct weapon_t
{
	char *Name;
	int iAmmoType;
	int iMax;
	int iSlot;
	int iSlotPos;
	int iId;
	int iFlags;
	int iMag;
};

struct ammo_t
{
	char *Name;
	int iId;
	int iNum;
	int cost;
};

struct buyitem_t
{
	char *name;
	int cost;
	int menu1;
	int menu2;
	int as;
	int de;
	int cs;
};

ammo_t *ammo_lookup(int id);
weapon_t *weapon_lookup(const char *Name);
weapon_t *weapon_lookup(int id);
weapon_t *weapon_lookup(edict_t *pEdict, int iSlot);
weapon_t *weapon_lookup(int mask, int iSlot);
buyitem_t *buyitem_lookup(int menu1, int menu2);
buyitem_t *buyitem_lookup(const char *name);
extern buyitem_t buyitems[];
extern weapon_t weapons[];

#endif
